<?

/*

 	Webmedia Explorer 5.0 - Multimedia Management System
 	Copyright (C) 2007 Marc Salmurri (marc.salmurri@gmail.com)

 	This program is free software; you can redistribute it and/or modify
 	it under the terms of the GNU General Public License as published by
 	the Free Software Foundation; either version 2 of the License, or (at
 	your option) any later version.

 	This program is distributed in the hope that it will be useful, but
 	WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 	General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with this program; if not, write to the Free Software
 	Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.

*/

$alpha_others = "@";

$alphas = array ( "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z" );

class folder
{
	var $path;
	var $config;

	var $rows = 0;
	var $num_rows = 0;
	var $i = 0;

	var $bookmarks;

	function folder ()
	{
		$this->rows = array ();
	}	

	function subfolders_path ( $path, $search = "", $tag = "", $recurse = 0, $post_mode = 0, $archive = 0 ) // 0 ignore posts, 1 consider posts, 2 exclusive post mode
	{
		global $icons;
		global $desc_file;
		global $tags_file;
		global $readme_file;
		global $config_file;
		global $rss_file;
		global $post_file;

		clearstatcache ();

		if ( !is_dir ( $GLOBALS["home"].$path."/." ) ) return false;

		$this->path 	= $path;

		$this->config 	= $this->_load_config ( $path );

		$type = "[subfolders_path][".$recurse."][".$post_mode."][".$archive."]";

		$this->rows = _get_cached ( $this->path, $type );

		if ( $this->rows === false )
		{
			$this->rows = array ();

			if ( $handle = opendir ( $GLOBALS["home"].$this->path ) )
			{
				$files = array ();

				while ( false !== ( $file = readdir ( $handle ) ) )
				{
					$filepath = $GLOBALS["home"].$this->path."/".$file;

					if ( is_dir ( $filepath ) && ( $file != "." ) && ( $file != ".." ) )
					{
						$item["name"] = $file;

						if ( is_dir ( $filepath ) ) $item["filetime"] = $this->get_time ( $filepath );

						$files[] = $item;
					}
				}

				closedir ( $handle );

				if ( $post_mode ) usort ( $files, "compare_by_filetime" );

				else usort ( $files, "compare" );

				$num_files = count ( $files );

				$this->i = 0;

				for ( $i = 0; $i < $num_files; $i++ )
				{
					$file 		= $files[$i]["name"];

					$path 		= $this->path."/".$file;

					$this->rows[$this->i]["name"] 			= $file;

					$this->rows[$this->i]["normalized"] 	= normalize ( $file );

					$this->rows[$this->i]["path"] 			= $path;

					$this->rows[$this->i]["filetime"] 		= $files[$i]["filetime"];

					$this->rows[$this->i]["size"]			= 100;
					$this->rows[$this->i]["desc"] 			= @file_get_contents ( $GLOBALS["home"].$path."/".$desc_file );
					$this->rows[$this->i]["readme"] 		= @file_get_contents ( $GLOBALS["home"].$path."/".$readme_file );
					$this->rows[$this->i]["config"] 		= $this->_load_config ();
					$this->rows[$this->i]["tags"] 			= @file_get_contents ( $GLOBALS["home"].$path."/".$tags_file );
					$this->rows[$this->i]["feeds"] 			= @file_get_contents ( $GLOBALS["home"].$path."/".$rss_file );

					$this->rows[$this->i]["icon"] 			= $icons["dir"];

					for ( $j = 0; $j < count ( $GLOBALS["cover_files"] ); $j++ )
					{
						$cover_file = $GLOBALS["home"].$path."/".$GLOBALS["cover_files"][$j];

						if ( file_exists ( $cover_file ) ) $this->rows[$this->i]["cover"] 	= $GLOBALS["cover_files"][$j];
					}

					for ( $j = 0; $j < count ( $GLOBALS["header_files"] ); $j++ )
					{
						$header_file = $GLOBALS["home"].$path."/".$GLOBALS["header_files"][$j];

						if ( file_exists ( $header_file ) ) $this->rows[$this->i]["header"] 	= $GLOBALS["header_files"][$j];
					}

					$this->i++;

					if ( $recurse )
					{
						$subfolders = new folder ();

						// don't search!

						if ( $post_mode ) $subfolders->subfolders_path ( $path, "", "", 1, 1 );		// consider posts

						else $subfolders->subfolders_path ( $path, "", "", 1, 0 );					// ignore posts

						if ( $subfolders->num_rows > 0 )
						{
							$this->rows = array_merge ( $this->rows, $subfolders->rows );

							$this->i = count ( $this->rows );										// we still are in a loop!
						}
					}
				}

				_set_cached ( $this->path, $type, $this->rows );									// cache it without search
			}
			else return false;
		}

		if ( count ( $this->rows ) > 0 )
		{
			if ( !empty ( $archive ) )
			{
				$parts = explode ( "-", $archive );

				$ini_time = mktime ( 0, 0, 0, $parts[1], 1, $parts[0] );

				$end_time = mktime ( 0, 0, 0, $parts[1] + 1, 1, $parts[0] );
			}

			$found_rows = array ();

			$this->num_rows = count ( $this->rows );

			for ( $this->i = 0; $this->i < $this->num_rows; $this->i++ )
			{
				if ( !empty ( $archive ) )
				{
					if ( ( $this->get ( "filetime" ) < $end_time ) && ( $this->get ( "filetime" ) >= $ini_time ) )
					{
						if ( $this->_found ( $search, $tag, $post_mode ) ) $found_rows[] = $this->rows[$this->i];	
					}
				}
				else if ( $this->_found ( $search, $tag, $post_mode ) ) $found_rows[] = $this->rows[$this->i];
			}

			$this->rows = $found_rows;

			if ( $post_mode ) usort ( $this->rows, "compare_by_filetime" );

			else if ( !$recurse )
			{
				if ( $this->config["sort"] )
				{
					usort ( $this->rows, "compare_by_order" );
				}
				else
				{
					usort ( $this->rows, "compare_normalized" );
				}
			}
		}

		$this->num_rows = 0;

		$this->num_rows = count ( $this->rows );

		$this->i = 0;

		return true;
	}

	function I_am_post ()
	{
		global $post_file;

		if ( eregi ( $post_file, $this->get ( "name" ) ) ) return true;

		return false;
	}

	function _found ( $search, $tag, $post_mode = 0 )
	{
		if ( ( $post_mode == 0 ) && $this->I_am_post () ) return false;

		if ( ( $post_mode == 2 ) && !$this->I_am_post () ) return false;

		if ( empty ( $tag ) && empty ( $search ) ) return true;

		if ( !empty ( $tag ) )
		{
			$parts = explode ( ";", $tag );

			if ( count ( $parts ) > 0 )
			{
				for ( $i = 0; $i < count ( $parts ); $i++ )
				{
					if ( !ereg ( "(^|;)".$parts[$i]."(;|$)", $this->get_tags_string () ) ) return false;
				}
				
				if ( empty ( $search ) ) return true;
			}
			else if ( ereg ( "(^|;)".$tag."(;|$)", $this->get_tags_string () ) )
			{
				if ( empty ( $search ) ) return true;
			}
		}

		if ( !empty ( $search ) )
		{
			if ( eregi ( $search, $this->get_tags_string () )|| eregi ( $search, $this->get ( "name" ) ) || eregi ( $search, $this->get ( "desc" ) ) || eregi ( $search, strip_tags ( $this->get ( "readme" ) ) ) ) return true;
		}

		return false;
	}

	function get_time ( $dir )
	{
		global $time_file;

		$filetime = $dir."/".$time_file;

		if ( !file_exists ( $filetime ) ) $this->_set_time ( $dir );

		return file_get_contents ( $filetime );
	}

	function _set_time ( $dir )
	{
		global $time_file;

		$time = @filectime ( $dir );

		_file_put_contents ( $dir."/".$time_file, $time );

		$this->set ( "filetime", $time );

		return $time;
	}

	function set_time ( $time, $dir = "" )
	{
		global $time_file;
		
		if ( empty ( $dir ) ) $dir = $GLOBALS["home"].$this->get ( "path" )."/";

		_file_put_contents ( $dir.$time_file, $time );

		$this->set ( "filetime", $time );

		return $time;
	}

	function set_config ( $options, $dir = "" )
	{
		global $config_file;

		if ( empty ( $dir ) ) $dir = $GLOBALS["home"].$this->get ( "path" )."/";
		
		$buffer = "";

		foreach ( $options as $key => $value )
		{
			$buffer .= $key."=".$value."\n";
		}

		_file_put_contents ( $dir.$config_file, $buffer );

		$this->set ( "config", $options );
	}

	function get_day (){ return substr ( date ( "Y-m-d H:i:s", $this->get ( "filetime" ) ), 8, 2 ); }
	
	function get_month (){ return substr ( date ( "Y-m-d H:i:s", $this->get ( "filetime" ) ), 5, 2 ); }
	
	function get_year (){ return substr ( date ( "Y-m-d H:i:s", $this->get ( "filetime" ) ), 0, 4 ); }
	
	function get_hour (){ return substr ( date ( "Y-m-d H:i:s", $this->get ( "filetime" ) ), 11, 2 ); }
	
	function get_minute (){ return substr ( date ( "Y-m-d H:i:s", $this->get ( "filetime" ) ), 14, 2 ); }
	
	function folder_path ( $path = "" )
	{
		global $icons;
		global $desc_file;
		global $tags_file;
		global $readme_file;
		global $config_file;
		global $rss_file;

		clearstatcache ();

		if ( empty ( $path ) && $this->rows ) $path = $this->get ( "path" );

		if ( !is_dir ( $GLOBALS["home"].$path ) ) return false;

		$this->config = $this->_load_config ( $path );

		$this->rows = array ();

		$this->rows[0]["name"] 				= get_name ( $path );
		
		$this->rows[0]["normalized"] 		= normalize ( $this->rows[0]["name"] );

		$this->rows[0]["path"]				= $path;

		$this->rows[0]["filetime"] 			= $this->get_time ( $GLOBALS["home"].$path );

		$this->rows[0]["size"]				= 100;
		$this->rows[0]["desc"] 				= @file_get_contents ( $GLOBALS["home"].$path."/".$desc_file );
		$this->rows[0]["readme"] 			= @file_get_contents ( $GLOBALS["home"].$path."/".$readme_file );
		$this->rows[0]["config"] 			= $this->_load_config ();
		$this->rows[0]["tags"] 				= @file_get_contents ( $GLOBALS["home"].$path."/".$tags_file );
		$this->rows[0]["feeds"] 			= @file_get_contents ( $GLOBALS["home"].$path."/".$rss_file );

		$this->rows[0]["icon"] 				= $icons["dir"];

		for ( $i = 0; $i < count ( $GLOBALS["cover_files"] ); $i++ )
		{
			$cover = $GLOBALS["home"].$path."/".$GLOBALS["cover_files"][$i];

			if ( file_exists ( $cover ) ) $this->rows[0]["cover"] = $GLOBALS["cover_files"][$i];
		}

		for ( $i = 0; $i < count ( $GLOBALS["header_files"] ); $i++ )
		{
			$header = $GLOBALS["home"].$path."/".$GLOBALS["header_files"][$i];

			if ( file_exists ( $header ) ) $this->rows[0]["header"] = $GLOBALS["header_files"][$i];
		}

		$this->num_rows = 1;

		return true;
	}

	function create_subfolder ( $data )
	{
		$path = $this->get ( "path" )."/".trim ( $data["name"] );

		set_dir	( $GLOBALS["home"].$path );

		$this->_set_time ( $GLOBALS["home"].$path );

		$this->folder_path ( $this->get ( "path" ) );

		$this->touch_me ();
	}

	function create_post ( $data )
	{
		global $post_file;
		global $lock_file;
		
		$fd = fopen ( $GLOBALS["path_data"]."/".$lock_file, "w" );

		if ( flock ( $fd, LOCK_EX ) )
		{
			$file_id = $GLOBALS["path_data"]."id_post";

			$max_id = file_get_contents ( $file_id );

			if ( ( $max_id === false ) && ( strlen ( $max_id ) == 0 ) )
			{
				$subtree = new folder ();

				$subtree->subfolders_path ( "/", "", "", 1, 2 );

				$max_id = str_replace ( "post_", "", $subtree->get ( "name" ) );
			}

			$max_id++;

			_file_put_contents ( $file_id, $max_id );

			$path = $this->get ( "path" )."/post_".$max_id;
				
			set_dir ( $GLOBALS["home"].$path );

			$post = new folder ();

			$post->folder_path ( $path );

			$post->set_desc ( $data["desc"] );

			$post->set_tags ( $data["tags"] );

			$post->set_readme ( $data["readme"] );
			
			$post->set_time ( mktime ( $data["hour"], $data["minute"], 0, $data["month"], $data["day"], $data["year"] ), $GLOBALS["home"].$path."/" );

			$options = array ();

			$options["hide_images"] = 0;

			if ( $data["hide_images"] ) $options["hide_images"] = 1;

			$post->set_config ( $options );

			$post->touch_me ();

			flock ( $fd, LOCK_UN );
		}

		fclose ( $fd );

		unlink ( $GLOBALS["path_data"]."/".$lock_file );
	}

	function create_message ( $data )
	{
		$data["path"] = $this->get ( "path" )."/";

		$message = new message ();

		$return = $message->create ( $data );

		$this->touch_me ();

		return $return;
	}
	
	function update_message ( $data )
	{
		$data["path"] = $this->get ( "path" )."/";

		$message = new message ();

		$message->message_path_message ( $this->get ( "path" ), $data["id_message"] );

		$return = $message->update ( $data );

		$this->touch_me ();

		return $return;
	}

	function delete_message ( $id_message )
	{
		$message = new message ();

		$message->message_path_message ( $this->get ( "path" ), $id_message );

		$id_ancestor = $message->get_ancestor ();

		$message->delete ();

		$this->touch_me ();

		return $id_ancestor;
	}

	function update ( $data )
	{
		$data["name"] = stripslashes ( $data["name"] );

		if ( ( strlen ( $data["name"] ) > 0 ) && ( $data["name"] != $this->get ( "name" ) ) )
		{
			$old_path = $this->get ( "path" );

			$new_path = get_parent ( $this->get ( "path" ) )."/".trim ( stripslashes ( $data["name"] ) );

			rename ( $GLOBALS["home"].$old_path, $GLOBALS["home"].$new_path );

			$this->folder_path ( $new_path );
		}

		$options = array ();

		$options["hide_images"] = 0;

		if ( $data["hide_images"] ) $options["hide_images"] = 1;
		
		$this->set_config ( $options );

		$this->set_desc ( $data["desc"] );

		$this->set_tags ( $data["tags"] );

		$this->set_readme ( $data["readme"] );

		$this->set_time ( mktime ( $data["hour"], $data["minute"], 0, $data["month"], $data["day"], $data["year"] ) );

		$this->set_feeds ( $data["feeds"] );

		$this->touch_me ();
	}

	function update_other ( $data )
	{
		$other = new other ();

		$other->other_path ( $this->get ( "path" ), $data["other"] );

		$other->delete_comment ();

		$other->set_name ( $data["name"] );

		$other->set_comment ( $data["comment"] );

		$this->touch_me ();
	}

	function upload_file ( $data )
	{
		move_uploaded_file ( $data["userfile"]["tmp_name"], $GLOBALS["home"].$this->get ( "path" )."/".$data["userfile"]["name"] );

		$this->touch_me ();
	}

	function update_image ( $data )
	{
		$image = new image ();

		$image->image_path ( $this->get ( "path" ), $data["image"] );

		$image->set_name ( $data["name"] );

		$image->set_comment ( $data["comment"] );

		$this->touch_me ();
	}

	function delete_other ( $other )
	{
		$others = new other ();

		$others->other_path ( $this->get ( "path" ), $other, 1 );

		$others->delete ();

		$this->touch_me ();
	}

	function delete_image ( $image )
	{
		$images = new image ();

		$images->image_path ( $this->get ( "path" ), $image, 1 );

		$images->delete ();

		$this->touch_me ();
	}		

	function _load_config ( $path = "" )
	{
		global $config_file;

		if ( empty ( $path ) ) $path = $this->get ( "path" );

		$configs = trim ( file_get_contents ( $GLOBALS["home"].$path."/".$config_file ) );

		$configs = explode ( "\n", $configs );

		if ( count ( $configs ) > 0 )
		{
			for ( $i = 0; $i < count ( $configs ); $i++ )
			{
				$config_array = explode ( "=", $configs[$i] );

				if ( !empty ( $config_array[0] ) && !empty ( $config_array[1] ) )
				{
					$_configs[$config_array[0]] = $config_array[1];
				}
			}
		}

		return $_configs;
	}

	function _load_bookmarks ()
	{
		global $bookmark_file;

		if ( count ( $this->bookmarks ) > 0 ) return $this->bookmarks;

		$bookmarks = trim ( file_get_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$bookmark_file ) );

		$bookmarks = explode ( "\n", $bookmarks );

		if ( count ( $bookmarks ) > 0 )
		{
			for ( $i = 0; $i < count ( $bookmarks ); $i++ )
			{
				$bookmark_array = explode ( ";", $bookmarks[$i] );

				if ( !empty ( $bookmark_array[0] ) )
				{
					$_bookmarks[$i]["url"] 		= trim ( $bookmark_array[0] );
					$_bookmarks[$i]["name"] 	= trim ( $bookmark_array[1] );
					$_bookmarks[$i]["comment"] 	= trim ( $bookmark_array[2] );
				}
			}
		}

		$this->bookmarks = $_bookmarks;

		return $_bookmarks;
	}

	function _save_bookmarks ( $bookmarks )
	{
		global $bookmark_file;

		usort ( $bookmarks, "compare" );

		$this->bookmarks = $bookmarks;

		$file_path = $GLOBALS["home"].$this->get ( "path" )."/".$bookmark_file;

		$buffer = "";

		for ( $i = 0; $i < count ( $bookmarks ); $i++ )
		{
			$buffer .= trim ( strip_tags ( str_replace ( ";", "", $bookmarks[$i]["url"] ) ) )."; ".trim ( stripslashes ( strip_tags ( str_replace ( ";", "", $bookmarks[$i]["name"] ) ) ) )."; ".trim ( stripslashes ( strip_tags ( str_replace ( ";", "", $bookmarks[$i]["comment"] ) ) ) )."\r\n";
		}

		if ( empty ( $buffer ) ) unlink ( $file_path );

		else _file_put_contents ( $file_path, $buffer );
		
		$this->touch_me ();
	}		

	function create_update_bookmark ( $data )
	{
		$bookmarks = $this->_load_bookmarks ();

		$item["url"] 		= trim ( strip_tags ( $data["url"] ) );
		$item["name"] 		= trim ( stripslashes ( strip_tags ( $data["name"] ) ) );
		$item["comment"] 	= trim ( stripslashes ( strip_tags ( $data["comment"] ) ) );

		if ( isset ( $data["bookmark"] ) )
		{
			$bookmarks[$data["bookmark"]] = $item;
		}

		else $bookmarks[] = $item;

		$this->_save_bookmarks ( $bookmarks );
	}

	function delete_bookmark ( $id_bookmark )
	{
		$bookmarks = $this->_load_bookmarks ();

		$new_bookmarks = array ();

		$j = 0;

		for ( $k = 0; $k < count ( $bookmarks ); $k++ )
		{
			if ( $id_bookmark != $k )
			{
				$new_bookmarks[$j++] = $bookmarks[$k];
			}
		}

		$this->_save_bookmarks ( $new_bookmarks );
	}		

	function copy ( $path )
	{
		$source = new folder ();

		if ( empty ( $path ) ) return false;

		if ( !$source->folder_path ( $path ) ) return false;

		cpdir ( $GLOBALS["home"].$source->get ( "path" ), $GLOBALS["home"].$this->get ( "path" )."/".$source->get ( "name" ) );

		$this->touch_me ();

		return $this->folder_path ();
	}

	function copy_other ( $path, $_other )
	{
		if ( empty ( $path ) ) return false;

		$other = new other ();

		if ( !$other->other_path ( $path, $_other, 1 ) ) return false;

		$comment = $other->get_comment ();

		$source = new folder ();

		if ( !$source->folder_path ( $path ) ) return false;

		$source_path = $GLOBALS["home"].$source->get ( "path" )."/";

		$dest_path = $GLOBALS["home"].$this->get ( "path" )."/";

		copy ( $source_path.$_other, $dest_path.$_other );

		chmod ( $dest_path.$_other, 0775 );

		$other->other_path ( $this->get ( "path" ), $_other, 1 );

		$other->set_comment ( $comment );

		$this->touch_me ();

		return $this->folder_path ();
	}
	
	function copy_bookmark ( $path, $bookmark )
	{
		$source = new folder ();

		if ( empty ( $path ) ) return false;

		if ( !$source->folder_path ( $path ) ) return false;

		$source_bookmarks = $source->_load_bookmarks ();
		
		$bookmarks = $this->_load_bookmarks ();

		$found = false;

		for ( $i = 0; $i < count ( $source_bookmarks ); $i++ )
		{
			if ( $bookmarks[$i]["url"] == $source_bookmarks[$bookmark]["url"] )
			{
				$bookmarks[$i] = $source_bookmarks[$bookmark];

				$found = true;
			}
		}
		
		if ( !$found ) $bookmarks[] = $source_bookmarks[$bookmark];

		$this->_save_bookmarks ( $bookmarks );

		$this->touch_me ();

		return $this->folder_path ();
	}

	function clear ()
	{
		$parent = get_parent ( $this->get ( "path" ) );

		rm ( $GLOBALS["home"].$this->get ( "path" ) );

		set_dir ( $GLOBALS["home"].$this->get ( "path" ) );

		$this->touch_me ();
	}

	function delete ()
	{
		if ( $this->get_level () == 0 ) return false;
	
		$parent = get_parent ( $this->get ( "path" ) );

		rm ( $GLOBALS["home"].$this->get ( "path" ) );

		$this->folder_path ( $parent );

		$this->touch_me ();
	}

	function touch_me ()
	{
		global $tmp_file;

		_file_put_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$tmp_file, "touching" );

		// Here!

		unlink ( $GLOBALS["home"].$this->get ( "path" )."/".$tmp_file );
		
		clearstatcache ();

		if ( $this->get_level () > 0 )
		{
			$parent = new folder ();

			$parent->folder_path ( get_parent ( $this->get ( "path" ) ) );

			$parent->touch_me ();
		}
	}

	function set ( $field, $value ){ $this->rows[$this->i][$field] = $value; }

	function protect ( $username, $password )
	{
		$htpasswd_file = $GLOBALS["home"].$this->get ( "path" )."/.htpasswd";

		_file_put_contents ( $htpasswd_file, $username.":".$this->_encrypt ( $password ) );

		$_SESSION["username: ".$this->get ( "path" )] = $username;

		$_SESSION["password: ".$this->get ( "path" )] = $password;

		$this->create_htaccess ();
	}
	
	function is_protected ()
	{
		clearstatcache ();

		return file_exists ( $GLOBALS["home"].$this->get ( "path" )."/.htpasswd" );
	}

	function unprotect ()
	{
		unlink ( $GLOBALS["home"].$this->get ( "path" )."/.htpasswd" );

		unlink ( $GLOBALS["home"].$this->get ( "path" )."/.htaccess" );
		
		unset ( $_SESSION["username: ".$this->get ( "path" )] );
		
		unset ( $_SESSION["password: ".$this->get ( "path" )] );

		$this->touch_me ();
	}	
	
	function get_htaccess_htpasswd_file ()
	{
		$path = realpath ( "." );

		$path = eregi_replace ( "^[a-z]:", "", $path );

		$htaccess_htpasswd_file = str_replace ( "\\", "/", $path );

		return $htaccess_htpasswd_file."/".$GLOBALS["home"].$this->get ( "path" )."/.htpasswd";
	}

	function create_htaccess ()
	{
		$htaccess_htpasswd_file = $this->get_htaccess_htpasswd_file ();

		$htaccess_file = $GLOBALS["home"].$this->get ( "path" )."/.htaccess";

    	$buffer = "AuthType        Basic\n";

    	$buffer .= "AuthUserFile    \"".$htaccess_htpasswd_file."\"\n";

    	$buffer .= "AuthName        \"".$this->get ( "path" )."\"\n";

    	$buffer .= "Require valid-user\n";

        _file_put_contents ( $htaccess_file, $buffer );

        $this->touch_me ();
	}
	
	function validate_user ()
	{
		if ( $this->get_level () > 0 )
		{
			$parent = new folder ();

			$parent->folder_path ( get_parent ( $this->get ( "path" ) ) );

			$parent->validate_user ();
		}

		if ( !$this->is_protected () ) return true;

		list ( $username, $password ) = explode ( ":", file_get_contents ( $GLOBALS["home"].$this->get ( "path" )."/.htpasswd" ) );

		if ( ( $_SESSION["username: ".$this->get ( "path" )] == $username ) && ( $this->_encrypt ( $_SESSION["password: ".$this->get ( "path" )] ) == $password ) ) return true;

		list ( $auth_username, $auth_password ) = explode ( ':', base64_decode ( substr ( $_GET['authorization'], 6 ) ) );

		if ( ( $auth_username == $username ) && ( $this->_encrypt ( $auth_password ) == $password ) )
		{
			$_SESSION["username: ".$this->get ( "path" )] = $auth_username;

			$_SESSION["password: ".$this->get ( "path" )] = $auth_password;

			return true;
		}

		header ( 'WWW-Authenticate: Basic realm="'.$this->get ( "path" ).'"' );

		header ( 'HTTP/1.0 401 Unauthorized' );

		exit;
	}

	function _encrypt ( $password ){ return '{SHA}'.base64_encode ( pack ( 'H40', sha1 ( $password ) ) ); }
	
	function get ( $field ){ return $this->rows[$this->i][$field]; }

	function clean_link ( $path )
	{
		$path = utf8_decode ( rawurldecode ( rawurldecode ( $path ) ) );

		$path = eregi_replace ( "(/\.\./)", "/", $path );

		$path = eregi_replace ( "(\.\.)?", "", $path );

		$path = eregi_replace ( "(/*/)$", "", $path );

		$path = eregi_replace ( "//", "/", $path );
		
		$path = stripslashes ( $path );

		if ( $path == "/" ) $path = "";
	
		return $path;
	}

	function get_path_link ()
	{
		return str_replace ( "%252F", "/", rawurlencode ( rawurlencode ( utf8_encode ( $this->get ( "path" ) ) ) ) );
	}

	function get_link ( $_url_index = "" )
	{
		global $url_index;
		
		if ( empty ( $_url_index ) ) $_url_index = $url_index;

		return $_url_index."?dir=".$this->get_path_link ();
	}

	function get_permalink ( $word = "folder" )					// folder
	{
		global $url_base;

		$path = $this->get_path_link ();

		$tail = "";

		if ( $this->I_am_post () ) $tail = "/".str_replace ( "%", "%25", eregi_replace ( "(\?|\&|\'|\"|,)", "", eregi_replace ( "( |\.)", "-", $this->get ( "desc" ) ) ) ).".html";

		return $url_base.$word.$path.$tail;
	}

	function get_reallink ( $encode = true )					// folder
	{
		global $url_base;

		if ( isset ( $_SERVER["WINDIR"] ) )
		{
			$path = str_replace ( "%2F", "/", rawurlencode ( utf8_encode ( $this->get ( "path" ) ) ) );
		}
		else
		{
			if ( $encode )
			{
				$path = str_replace ( "%2F", "/", str_encode ( $this->get ( "path" ) ) );
			}
			else
			{
				$path = str_replace ( "%2F", "/", rawurlencode ( $this->get ( "path" ) ) );
			}
		}

		return $url_base.$GLOBALS["home"].$path."/";
	}

	function get_buffer ( $read_more = false, $images = true, $page = -1 )
	{
		global $image_templates;

		$regs = array ();

		$buffer = $this->get ( "readme" );

		if ( $images )
		{
			while ( eregi ( "\[image:([^]|]*)\|?(left|right|center)?\|?([0-9]*%?)?\]", $buffer, $regs ) )
			{
				$max = $regs[3];

				$image = new image ();

				$image->image_path ( $this->get ( "path" ), $regs[1], 1 );

				if ( empty ( $regs[3] ) ) $max = "150";

				else if ( eregi ( "%", $max ) )
				{
					$max = str_replace ( "%", "", $regs[3] );

					if ( $max > 100 ) $max = 100;

					$width = $GLOBALS["width"] - $GLOBALS["side"][$GLOBALS["width"]] - ( $GLOBALS["margin"] * 3.2 );

					$max = round ( ( $max * $width ) / 100 );

					if ( ( $image->get ( "width" ) < $width ) && ( $max < $image->get ( "width" ) ) ) $width = $image->get ( "width" );
				}

				ob_start ();

				$image->render_max ( $max, $image_templates[$regs[2]] );

				$image_buffer = ob_get_clean ();

				$buffer = eregi_replace ( "\[image:(".$regs[1].")\|?(".$regs[2].")?\|?(".$regs[3].")?\]", $image_buffer, $buffer );
			}
		}
		else
		{
			$buffer = eregi_replace ( "\[image:([^]|]*)\|?(left|right|center)?\|?([0-9]*%?)?\]", "", $buffer );
		}
		
		if ( !$read_more )
		{
			$buffer = str_replace ( "[read_more]", "", $buffer );

			if ( ( $page >= 0 ) && ( strpos ( $buffer, "[page_break]" ) ) )
			{
				$parts = explode ( "[page_break]", $buffer );

				$n_parts = count ( $parts );

				if ( $page > $n_parts ) $page = $n_parts - 1;
			
				$buffer = $parts[$page];
				
				$buffer = eregi_replace ( "^(<br>)+", "", $buffer );

				$buffer = eregi_replace ( "(<br>)+$", "", $buffer );
			}
			else
			{
				return str_replace ( "[page_break]", "", $buffer );
			}
			
			return $buffer;
		}
		else if ( strpos ( $buffer, "[read_more]" ) )
		{
			$buffer = str_replace ( "[page_break]", "", $buffer );
		
			return substr ( $buffer, 0, strpos ( $buffer, "[read_more]" ) )." ... [<a href=\"".$this->get_permalink ()."\">".$GLOBALS["lang"]["go_on_reading"]."</a>]";
		}
		else
		{
			if ( strpos ( $buffer, "[page_break]" ) )
			{
				$parts = explode ( "[page_break]", $buffer );
				
				$buffer = $parts[0]." <a href=\"".$this->get_permalink ()."\">".$GLOBALS["lang"]["go_on_reading"]."</a>";
			}
			else
			{
				$buffer = str_replace ( "[page_break]", "", $buffer );
			}

			return $buffer;
		}
	}
	
	function get_buffer_pages ()
	{
		$parts = explode ( "[page_break]", $this->get ( "readme" ) );

		return count ( $parts );
	}

	function set_desc ( $desc )
	{
		global $desc_file;

		$desc = trim ( stripslashes ( $desc ) );

		$this->set ( "desc", $desc );

		if ( empty ( $desc ) ) return unlink ( $GLOBALS["home"].$this->get ( "path" )."/".$desc_file );

		return _file_put_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$desc_file, $desc );
	}

	function get_desc ()
	{
		global $desc_file;

		return @file_get_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$desc_file );
	}

	function set_tags ( $tags )
	{
		global $tags_file;

		$tags = trim ( stripslashes ( $tags ) );

		$this->set ( "tags", $tags );

		if ( empty ( $tags ) ) return unlink ( $GLOBALS["home"].$this->get ( "path" )."/".$tags_file );

		return _file_put_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$tags_file, $tags );
	}
/*
	function get_tags ()
	{
		global $tags_file;

		return file_get_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$tags_file );
	}
*/
	function set_readme ( $readme )
	{
		global $readme_file;

		$readme = stripslashes ( trim ( $readme ) );

		if ( $readme == "<br>" ) 			$readme = "";
		
		if ( $readme == "<br>&nbsp;" ) 		$readme = "";
		
		if ( $readme == "&nbsp;" ) 			$readme = "";
		
		if ( $readme == "<P>&nbsp;</P>" )	$readme = "";
		
		$this->set ( "readme", $readme );

		if ( empty ( $readme ) ) return unlink ( $GLOBALS["home"].$this->get ( "path" )."/".$readme_file );

		return _file_put_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$readme_file, $readme );
	}

	function get_readme ()
	{
		global $readme_file;

		return file_get_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$readme_file );
	}

	function set_feeds ( $feeds )
	{
		global $rss_file;

		$feeds = trim ( $feeds );

		$this->set ( "feeds", $feeds );

		if ( empty ( $feeds ) ) return unlink ( $GLOBALS["home"].$this->get ( "path" )."/".$rss_file );

		return _file_put_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$rss_file, $feeds );
	}

	function get_feeds ()
	{
		global $rss_file;

		return file_get_contents ( $GLOBALS["home"].$this->get ( "path" )."/".$rss_file );
	}

	function get_level ()
	{
		if ( ( $this->get ( "path" ) == "/" ) || ( $this->get ( "path" ) == "" ) ) return 0;
	
		$parts = explode ( "/", $this->get ( "path" ) );

		return count ( $parts ) - 1;
	}

	function get_path_level ( $level )
	{
		$parts = explode ( "/", $this->get ( "path" ) );

		$path = "";

		for ( $i = 1; $i <= $level; $i++ ) $path .= "/".$parts[$i];

		return $path;
	}

	function get_images ( $search, $exact = 0, $recurse = 0, $post_mode = 1 )
	{
		$images = new image ();

		$images->image_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode );

		return $images->rows;
	}

	function get_others ( $search, $exact = 0, $recurse = 0, $post_mode = 1 )
	{
		$others = new other ();

		$others->other_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode );

		return $others->rows;
	}

	function get_messages ( $search, $exact = 0, $recurse = 0, $post_mode = 1, $all = 0 )
	{
		$messages = new message ();

		$messages->message_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode, $all );

		return $messages->rows;
	}

	function get_num_images ( $search = "", $exact = 0, $recurse = 0, $post_mode = 0 )
	{
		$name = "[num_images][".$search."][".$exact."][".$recurse."][".$post_mode."]";

		$value = _get_cached ( $this->get ( "path" ), $name );

		if ( $value === false )
		{
			$images = new image ();

			$images->image_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode );

			$value = $images->num_rows;

			_set_cached ( $this->get ( "path" ), $name, $value );
		}

		return $value;
	}

	function get_num_others ( $search = "", $exact = 0, $recurse = 0, $post_mode = 0 )
	{
		$name = "[num_others][".$search."][".$exact."][".$recurse."][".$post_mode."]";

		$value = _get_cached ( $this->get ( "path" ), $name );

		if ( $value === false )
		{
			$others = new other ();

			$others->other_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode );

			$value = $others->num_rows;

			_set_cached ( $this->get ( "path" ), $name, $value );
		}

		return $value;
	}

	function get_num_subtree_others ( $search = "", $exact = 0, $recurse = 1, $post_mode = 1 )
	{
		$name = "[num_others][".$search."][".$exact."][".$recurse."][".$post_mode."]";

		$value = _get_cached ( $this->get ( "path" ), $name );

		if ( $value === false )
		{
			$others = new other ();

			$others->other_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode );

			$value = $others->num_rows;

			_set_cached ( $this->get ( "path" ), $name, $value );
		}

		return $value;
	}

	function get_num_tree ( $search = "", $tag = "", $recurse = 0, $post_mode = 0 )
	{
		$name = "[num_tree][".$search."][".$tag."][".$recurse."][".$post_mode."]";

		$value = _get_cached ( $this->get ( "path" ), $name );

		if ( $value === false )
		{
			$subtree = new folder ();

			$subtree->subfolders_path ( $this->get ( "path" ), $search, $tag, 1, $post_mode );

			$value = $subtree->num_rows;
			
			if ( $this->_found ( $search, $tag ) ) $value++;

			_set_cached ( $this->get ( "path" ), $name, $value );
		}

		return $value;
	}

	function get_num_messages ( $search = "", $exact = "", $recurse = 0, $post_mode = 0, $all = 0 )
	{
		$name = "[num_messages][".$search."][".$exact."][".$recurse."][".$post_mode."][".$all."]";

		$value = _get_cached ( $this->get ( "path" ), $name );

		if ( $value === false )
		{
			$messages = new message ();

			$messages->message_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode, $all );

			$value = $messages->num_rows;

			_set_cached ( $this->get ( "path" ), $name, $value );
		}

		return $value;
	}

	function get_num_posts ( $search = "", $tag = "", $recurse = 0, $archive = "" )
	{
		$posts = new folder ();

		$posts->subfolders_path ( $this->get ( "path" ), $search, $tag, $recurse, 2, $archive );

		if ( $_SESSION["user"] == "admin" ) return $posts->num_rows;

		$now = mktime ();

		$i = 0;

		for ( $posts->i = 0; $posts->i < $posts->num_rows; $posts->i++ )
		{
			if ( $posts->get ( "filetime" ) <= $now ) $i++;
		}

		return $i;
	}

	function get_num_subfolders ( $search = "", $tag = "", $recurse = 0, $post_mode = 0 )
	{
		$name = "[num_subfolders][".$search."][".$tag."][".$recurse."][".$post_mode."]";

		$value = _get_cached ( $this->get ( "path" ), $name );

		if ( $value === false )
		{
			$subfolders = new folder ();

			$subfolders->subfolders_path ( $this->get ( "path" ), $search, $tag, $recurse, $post_mode );

			$value = $subfolders->num_rows;

			_set_cached ( $this->get ( "path" ), $name, $value );
		}

		return $value;
	}

	function get_total (){ return $this->get_num_subfolders () + $this->get_num_posts () + $this->get_num_images () + $this->get_num_others (); }

	function render ( $template, $ini = 0, $num = 0 )
	{
		if ( $num == 0 ) $num = $this->num_rows;

		for ( $this->i = $ini; ($this->i < $ini + $num) && ($this->i < $this->num_rows); $this->i++ ) include ( $GLOBALS["path_template"].$template );
	}

	function render_I_am_post_if ( $template )
	{
		if ( $this->I_am_post () ) include ( $GLOBALS["path_template"].$template );
	}

	function render_subfolders ( $template, $search = "", $tag = "", $ini = 0, $num = 0, $cache = true )
	{
		$type = "[render_subfolders][".$template."][".$search."][".$tag."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( !$cache || ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$subfolders = new folder ();

			$subfolders->subfolders_path ( $this->get ( "path" ), $search, $tag, 0, 0 );

			ob_start ();

			$subfolders->render ( $template, $ini, $num );

			$buffer = ob_get_clean ();

			if ( $cache ) _set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_subfolders_if ( $template, $null_template = "" )
	{
		if ( $this->get_num_subfolders ( "", "", 0, 0 ) > 0 ) include ( $GLOBALS["path_template"].$template );
		
		else if ( !empty ( $null_template ) ) include ( $GLOBALS["path_template"].$null_template );
	}

	function render_tree_with_alphas ( $template, $template_alpha, $template_anchor, $search = "", $tag = "", $post_mode = 0 )
	{
		$type = "[render_tree_with_alphas][".$template."][".$template_alpha."][".$template_anchor."][".$search."][".$tag."][".$post_mode."][".$GLOBALS["root_color"]."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$subtree = new folder ();

			$subtree->subfolders_path ( $this->get ( "path" ), $search, $tag, 1, $post_mode );

			ob_start ();

			$subtree->render_with_alphas ( $template, $template_alpha, $template_anchor );

			$buffer = ob_get_clean ();

			_set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_tree_with_cols ( $template, $template_alpha, $template_anchor, $num_cols, $search = "", $tag = "", $post_mode = 0 )
	{
		$type = "[render_tree_with_cols][".$template."][".$template_alpha."][".$template_anchor."][".$num_cols."][".$search."][".$tag."][".$post_mode."][".$GLOBALS["root_color"]."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$subtree = new folder ();

			$subtree->subfolders_path ( $this->get ( "path" ), $search, $tag, 1, $post_mode );

			ob_start ();

			$subtree->render_with_cols ( $template, $template_alpha, $template_anchor, $num_cols );

			$buffer = ob_get_clean ();

			_set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_subtree ( $template, $search = "", $tag = "" )
	{
		$type = "[render_subtree][".$template."][".$search."][".$tag."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$subtree = new folder ();

			$post_mode = 0;

			if ( !empty ( $search ) || !empty ( $tag ) ) $post_mode = 1;

			$subtree->subfolders_path ( $this->get ( "path" ), $search, $tag, 1, $post_mode );

			ob_start ();

			$subtree->render ( $template, 0, 0 );

			$buffer = ob_get_clean ();

			_set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_subtree_posts ( $template, $search = "", $tag = "", $ini = 0, $num = 0, $archive = "" )
	{
		$subtree = new folder ();

		$subtree->subfolders_path ( $this->get ( "path" ), $search, $tag, 1, 2, $archive );

		if ( $GLOBALS["user"]->is_admin () ) return $subtree->render ( $template, $ini, $num );

		$now = mktime ();

		$posts = new folder ();

		$posts->rows = array ();

		for ( $subtree->i = 0; $subtree->i < $subtree->num_rows; $subtree->i++ )
		{
			if ( $subtree->get ( "filetime" ) <= $now )
			{
				$posts->rows[$posts->i] = $subtree->rows[$subtree->i];

				$posts->i++;
			}
		}

		$posts->num_rows = $posts->i;

		$posts->i = 0;

		return $posts->render ( $template, $ini, $num );
	}

	function render_subtree_posts_archives ( $template )
	{
		global $months;

		$active_months = array ();

		$now = mktime ();

		$subtree = new folder ();

		$subtree->subfolders_path ( $this->get ( "path" ), "", "", 1, 2 );

		for ( $subtree->i = 0; $subtree->i < $subtree->num_rows; $subtree->i++ )
		{
			if ( ( $_SESSION["user"] == "admin" ) || ( ( $_SESSION["user"] != "admin" ) && ( $subtree->get ( "filetime" ) <= $now ) ) )
			{
				$id_month 	= date ( "n", $subtree->get ( "filetime" ) );

				$id_year 	= date ( "Y", $subtree->get ( "filetime" ) );

				if ( !isset ( $active_months[$id_year][$id_month] ) ) $active_months[$id_year][$id_month] = 0;

				$active_months[$id_year][$id_month] += 1;
			}
		}

		foreach ( $active_months as $key => $value )
		{
			$year = $key;

			foreach ( $value as $month => $num )
			{
				include ( $GLOBALS["path_template"].$template );
			}
		}
	}

	function render_subtree_posts_archives_if ( $template )
	{
		$active_months = array ();

		$subtree = new folder ();

		$subtree->subfolders_path ( $this->get ( "path" ), "", "", 1, 2 );

		for ( $subtree->i = 0; $subtree->i < $subtree->num_rows; $subtree->i++ )
		{
			$id_month = date ( "n", $subtree->get ( "filetime" ) );

			if ( $id_month != date ( "n" ) )
			{
				include ( $GLOBALS["path_template"].$template );

				break;
			}
		}
	}

	function render_subtree_others ( $template, $search = "" )
	{
		$type = "[render_subtree_others][".$template."][".$search."][".$GLOBALS["root_color"]."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$others = new other ();

			$others->other_path ( $this->get ( "path" ), $search, 0, 1, 1 );

			ob_start ();

			$others->render ( $template );

			$buffer = ob_get_clean ();

			_set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_path ( $template, $end_template = "", $skip = 0 )
	{
		global $post_file;

		$end = 0;

		if ( eregi ( $post_file, $this->get ( "name" ) ) ) $end = 1;

		if ( empty ( $end_template ) ) $end_template = $template;

		$parts = explode ( "/", $this->get ( "path" ) );

		$path = "";

		$folder = new folder ();

		if ( $skip > count ( $parts ) - 1 ) $skip = count ( $parts ) - 1;

		for ( $i = 1; $i <= $skip; $i++ )
		{
			$path .= "/".$parts[$i];
		}

		for ( ; $i < count ( $parts ) - 1; $i++ )
		{
			$path .= "/".$parts[$i];

			$folder->folder_path ( $path );
			
			include ( $GLOBALS["path_template"].$template );
		}

		if ( $i < count ( $parts ) - $end )
		{
			$path .= "/".$parts[$i];
			
			$folder->folder_path ( $path );
			
			include ( $GLOBALS["path_template"].$end_template );
		}
	}

	function render_parent ( $template )
	{
		$folder = new folder ();

		$folder->folder_path ( get_parent ( $this->get ( "path" ) ) );

		$folder->render ( $template );
	}

	function render_level_parent ( $level, $template )
	{
		$path = $this->get_path_level ( $level );

		$parent = new folder ();

		$parent->folder_path ( $path );

		$parent->render ( $template );
	}

	function render_parent_path ( $template, $end_template = "", $skip = 0 )
	{
		$parent = new folder ();

		$parent->folder_path ( get_parent ( $this->get ( "path" ) ) );

		$parent->render_path ( $template, $end_template, $skip );
	}

	function render_subfolders_with_alphas ( $template, $template_alpha, $template_anchor, $cache = true )
	{
		$type = "[render_subfolders_with_alphas][".$template."][".$template_alpha."][".$template_anchor."][".$GLOBALS["root_color"]."][".$GLOBALS["language"]."][".$GLOBALS["dir"]."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( !$cache || ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$subfolders = new folder ();

			$subfolders->subfolders_path ( $this->get ( "path" ) );

			ob_start ();

			$subfolders->render_with_alphas ( $template, $template_alpha, $template_anchor );

			$buffer = ob_get_clean ();

			if ( $cache ) _set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_with_alphas ( $template, $template_alpha, $template_anchor )
	{
		global $alpha_limit;
		global $alphas;
		global $alpha_others;
		global $init_done;

		$init_done = 1;

		$this->i = 0;

		if ( $this->num_rows > $alpha_limit )
		{
			include ( $GLOBALS["path_template"].$template_alpha );

			$alpha = $alpha_others;

			include ( $GLOBALS["path_template"].$template_anchor );

			for ( $i = 0; $i < count ( $alphas ); $i++ )
			{
				$alpha = strtoupper ( $alphas[$i] );

				include ( $GLOBALS["path_template"].$template_anchor );
			}
		}
		else
		{
			$this->render ( $template );
		}
	}
	
	function surpass_alpha_limit ()
	{
		global $alpha_limit;

		return $this->get_num_subfolders () > $alpha_limit;
	}

	function parent_surpasses_alpha_limit ()
	{
		global $alpha_limit;

		$parent = new folder ();

		$parent->folder_path ( get_parent ( $this->get ( "path" ) ) );

		return $parent->get_num_subfolders () > $alpha_limit;
	}

	function render_alpha ( $alpha, $template, $init_done )
	{
		global $alphas;
		global $alpha_others;

		for ( ; $this->i < $this->num_rows; )
		{
			$_alpha = strtolower ( $this->rows[$this->i]["normalized"][0] );

			if ( ( strtolower ( $alpha ) == $alpha_others ) && ( !in_array ( $_alpha, $alphas ) ) || ( strtolower ( $alpha ) != $alpha_others ) && ( $_alpha == strtolower ( $alpha ) ) )
			{
				$this->render ( $template, $this->i, 1 );

				if ( $init_done == 1 ) $init_done = 0;
			}

			else break;
		}

		return $init_done;
	}

	function render_alphas ( $template, $template_null )
	{
		global $alphas;
		global $alpha_others;

		$num_alphas = count ( $alphas );

		$this->i = 0;

		$i = 0;

		$alpha = $alpha_others;

		if ( !in_array ( strtolower ( substr ( $this->get ( "normalized" ), 0 , 1 ) ), $alphas ) )
		{
			include ( $GLOBALS["path_template"].$template );

			while ( ( !in_array ( strtolower ( substr ( $this->get ( "normalized" ), 0 , 1 ) ), $alphas ) ) && ( $this->i < $this->num_rows ) ) $this->i++;
		}
		else include ( $GLOBALS["path_template"].$template_null );

		for ( $i = 0; $i < $num_alphas; $i++ )
		{
			$alpha = ucfirst ( $alphas[$i] );

			if ( strtolower ( substr ( $this->get ( "normalized" ), 0 , 1 ) ) == strtolower ( $alpha ) )
			{
				include ( $GLOBALS["path_template"].$template );
			}
			else include ( $GLOBALS["path_template"].$template_null );

			while ( ( strtolower ( substr ( $this->get ( "normalized" ), 0 , 1 ) ) == strtolower ( $alpha ) ) && ( $this->i < $this->num_rows ) ) $this->i++;
		}

		$this->i = 0;
	}

	function render_subfolders_with_cols ( $template, $template_alpha, $template_anchor, $num_cols )
	{
		$type = "[render_subfolders_with_cols][".$template."][".$template_alpha."][".$template_anchor."][".$num_cols."][".$GLOBALS["root_color"]."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$subfolders = new folder ();

			$subfolders->subfolders_path ( $this->get ( "path" ) );

			ob_start ();

			$subfolders->render_with_cols ( $template, $template_alpha, $template_anchor, $num_cols );

			$buffer = ob_get_clean ();

			_set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}
	
	function render_with_cols ( $template, $template_alpha, $template_anchor, $num_cols )
	{
		global $alpha_limit;
		global $alphas;
		global $alpha_others;
		global $init_done;

		$init_done = 1;	
		
		$this->i = 0;

		if ( $this->num_rows > $alpha_limit )
		{
			include ( $GLOBALS["path_template"].$template_alpha );

			$alpha = $alpha_others;

			include ( $GLOBALS["path_template"].$template_anchor );

			for ( $i = 0; $i < count ( $alphas ); $i++ )
			{
				$alpha = strtoupper ( $alphas[$i] );

				include ( $GLOBALS["path_template"].$template_anchor );
			}
		}
		else
		{
			$this->render_cols ( $template, $num_cols );
		}
	}

	function render_alpha_cols ( $alpha, $template, $num_cols, $init_done )
	{
		global $alphas;
		global $alpha_others;

		for ( ; $this->i < $this->num_rows; )
		{
			$_alpha = strtolower ( $this->rows[$this->i]["normalized"][0] );

			if ( ( strtolower ( $alpha ) == $alpha_others ) && ( !in_array ( $_alpha, $alphas ) ) || ( strtolower ( $alpha ) != $alpha_others ) && ( $_alpha == strtolower ( $alpha ) ) )
			{
				$this->render_cols ( $template, $num_cols, $alpha );

				if ( $init_done == 1 ) $init_done = 0;
			}

			else break;
		}

		return $init_done;
	}

	function render_cols ( $template, $num_cols, $alpha = "", $init_done = false )
	{
		global $alphas;
		global $alpha_others;

		if ( empty ( $alpha ) )
		{
			for ( $this->i = 0; $this->i < $this->num_rows; ) include ( $GLOBALS["path_template"].$template );
		}
		else
		{
			for ( ; $this->i < $this->num_rows; )
			{
				$_alpha = strtolower ( $this->rows[$this->i]["normalized"][0] );

				if ( ( ( strtolower ( $alpha ) == $alpha_others ) && ( !in_array ( $_alpha, $alphas ) ) ) || ( ( strtolower ( $alpha ) != $alpha_others ) && ( $_alpha == strtolower ( $alpha ) ) ) )
				{
					include ( $GLOBALS["path_template"].$template );
				}

				else break;
			}
		}
	}

	function render_row ( $template, $num, $alpha = "" )
	{
		global $alphas;
		global $alpha_others;

		if ( empty ( $alpha ) )
		{
			for ( $ini = $this->i; ( $this->i < $ini + $num) && ($this->i < $this->num_rows); $this->i++ ) include ( $GLOBALS["path_template"].$template );
		}
		else
		{
			for ( $ini = $this->i; ( $this->i < $ini + $num) && ($this->i < $this->num_rows); )
			{
				$_alpha = strtolower ( $this->rows[$this->i]["normalized"][0] );

				if ( ( strtolower ( $alpha ) == $alpha_others ) && ( !in_array ( $_alpha, $alphas ) ) || ( strtolower ( $alpha ) != $alpha_others ) && ( $_alpha == strtolower ( $alpha ) ) )
				{
					include ( $GLOBALS["path_template"].$template );

					$this->i++;
				}

				else break;
			}
		}
	}

	function render_images ( $template, $ini = 0, $num = 0, $image = "" )
	{
		$images = new image ();

		$images->image_path ( $this->get ( "path" ), $image );

		$images->render ( $template, $ini, $num );
	}

	function render_images_cols ( $template, $num_cols, $ini, $num, $image = "" )
	{
		$images = new image ();

		$images->image_path ( $this->get ( "path" ), $image );

		$images->render_cols ( $template, $num_cols, $ini, $num );
	}

	function render_images_if ( $template ){ if ( $this->get_num_images () > 0 ) include ( $GLOBALS["path_template"].$template ); }

	function render_images_readme_if ( $template )
	{
		$config = $this->get ( "config" );

		if ( !isset ( $config["hide_images"] ) && $this->get_num_images () > 0 ) include ( $GLOBALS["path_template"].$template );
	}

	function render_images_nav_if ( $place, $template, $ini = 0 )
	{
		if ( $this->get_num_images () > 0 ) include ( $GLOBALS["path_template"].$template );
	}

	function render_images_nav ( $template, $ini, $num )
	{
		global $arrows;

		$total = $this->get_num_images ();

		$max_ini = $total - 1 - $num;
		
		$i = $ini;

		include ( $GLOBALS["path_template"].$template );
	}

	function render_image_nav_if ( $place, $template, $image = "" )
	{
		$images = new image ();

		$images->image_path ( $this->get ( "path" ), $image );

		include ( $GLOBALS["path_template"].$template );
	}

	function render_image ( $file, $template )
	{
		$image = new image ();

		$image->image_path ( $this->get ( "path" ), $file, 1 );

		$image->render ( $template );
	}

	function render_cover ( $template )
	{
		$image = new image ();

		$image->image_path ( $this->get ( "path" ), $this->get ( "cover" ), 1 );

		$image->render ( $template );
	}

	function render_bookmark ( $template, $bookmark = "" )
	{
		$bookmarks = $this->_load_bookmarks ();

		$i = $bookmark;

		include ( $GLOBALS["path_template"].$template );
	}

	function render_other ( $template, $search = "" )
	{
		$others = new other ();

		$others->other_path ( $this->get ( "path" ), $search, 1 );

		$others->render ( $template );
	}

	function render_others ( $template, $search = "" )
	{
		$others = new other ();

		$others->other_path ( $this->get ( "path" ), $search );

		$others->render ( $template );
	}

	function render_m3u_if ( $template )
	{
		if ( $this->get_num_audio () > 1 ) include ( $GLOBALS["path_template"].$template );
	}

	function get_num_audio ()
	{
		return $this->get_num_others ( "\.(aif|aiff|au|mid|mp3|flac|snd|wav|wma)$" );
	}

	function create_m3u ()
	{
		$others = new other ();

		$others->other_path ( $this->get ( "path" ) );

		$buffer = "#EXTM3U\n";
		
		$user_password = "";

		if ( strlen ( $_SESSION["username: ".$this->get ( "path" )] ) > 0 )
		{
			$user_password = $_SESSION["username: ".$this->get ( "path" )].":".$_SESSION["password: ".$this->get ( "path" )]."@";
		}

		for ( $others->i = 0; $others->i < $others->num_rows; $others->i++ )
		{
			if ( eregi ( "\.(aif|aiff|au|mid|mp3|flac|snd|wav|wma)$", $others->get ( "name" ) ) )
			{
				$buffer .= "#EXTINF:-1,".eregi_replace ( "\.(aif|aiff|au|mid|mp3|flac|snd|wav|wma)$", "", $others->get ( "name" ) )."\n";

				$buffer .= "http://".$user_password.$_SERVER["HTTP_HOST"].$others->get_permalink ()."\n";
			}
		}

		return $buffer;
	}

	function render_message ( $id_message, $template )
	{
		$message = new message ();

		$message->message_path_message ( $this->get ( "path" ), $id_message );

		$message->render ( $template );
	}

	function render_messages ( $template, $ini, $num, $search = "", $exact = 0, $recurse = 0, $post_mode = 0, $all = 0 )
	{
		$type = "[render_messages][".$template."][".$ini."][".$num."][".$search."][".$exact."][".$recurse."][".$post_mode."][".$all."][".$GLOBALS["language"]."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		if ( ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			$messages = new message ();

			$messages->message_path ( $this->get ( "path" ), $search, $exact, $recurse, $post_mode, $all );

			ob_start ();

			$messages->render ( $template, $ini, $num );

			$buffer = ob_get_clean ();

			_set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_messages_if ( $template, $search = "", $exact = 0, $recurse = 1, $post_mode = 1, $null_template = "" )
	{
		if ( $this->get_num_messages ( $search, $exact, $recurse, $post_mode ) > 0 ) include ( $GLOBALS["path_template"].$template );
		
		else if ( !empty ( $null_template ) ) include ( $GLOBALS["path_template"].$null_template );
	}

	function render_posts ( $template, $search = "", $tag = "", $archive = "" )
	{
		$posts = new folder ();

		$posts->subfolders_path ( $this->get ( "path" ), $search, $tag, 0, 2, $archive );

		$posts->render ( $template );
	}

	function render_posts_if ( $template, $template_alt = "", $archive = "" )
	{
		if ( $this->get_num_posts ( "", "", 0, $archive ) > 0 ) include ( $GLOBALS["path_template"].$template );

		else if ( !empty ( $template_alt ) ) include ( $GLOBALS["path_template"].$template_alt );
	}

	function render_readme_if ( $template )
	{
		global $readme_file;

		if ( file_exists ( $GLOBALS["home"].$this->get ( "path" )."/".$readme_file ) ) include ( $GLOBALS["path_template"].$template );
	}

	function render_me_if_I_am ( $template )
	{
		$tags = $this->get ( "tags" );

		$desc = $this->get ( "desc" );

		$readme = $this->get ( "readme" );

		if ( !empty ( $tags ) || !empty ( $desc ) || !empty ( $readme ) ) include ( $GLOBALS["path_template"].$template );
	}

	function render_me_if_tags ( $template )
	{
		$tags = $this->get ( "tags" );

		if ( !empty ( $tags ) ) include ( $GLOBALS["path_template"].$template );
	}		

	function render_me_if_found ( $template, $search, $tag = "" )
	{
		if ( $this->_found ( $search, $tag ) ) include ( $GLOBALS["path_template"].$template );
	}

	function render_bookmarks ( $template )
	{
		$bookmarks = $this->_load_bookmarks ();

		$num_bookmarks = count ( $bookmarks );

		for ( $i = 0; $i < $num_bookmarks; $i++ ) include ( $GLOBALS["path_template"].$template );
	}

	function get_num_bookmarks ()
	{
		$bookmarks = $this->_load_bookmarks ();			

		return count ( $bookmarks );
	}

	function render_bookmarks_if ( $template )
	{
		global $bookmark_file;

		if ( file_exists ( $GLOBALS["home"].$this->get ( "path" )."/".$bookmark_file ) ) include ( $GLOBALS["path_template"].$template );
	}	

	function render_if_not_root ( $template )
	{
		if ( $this->get_level () > 0 )  include ( $GLOBALS["path_template"].$template );
	}

	function render_tags ( $template )
	{
		$tags = $this->get_tags_string ();

		$tags = explode ( ";", $tags );

		$num_tags = count ( $tags );

		for ( $i = 0; $i < $num_tags; $i++ ) { $tags[$i] = trim ( $tags[$i] ); if ( !empty ( $tags[$i] ) )include ( $GLOBALS["path_template"].$template ); }
	}

	function get_num_tags ()
	{
		if ( $tags = $this->get_tags_string () ) return count ( $tags );

		return 0;
	}

	function render_tags_if ( $template )
	{
		global $tags_file;

		if ( file_exists ( $GLOBALS["home"].$this->get ( "path" )."/".$tags_file ) ) include ( $GLOBALS["path_template"].$template );
	}

	function get_tags_string ()
	{
		$tags = trim ( $this->get ( "tags" ), ";" );

		$tags = explode ( ";", $tags );

		$result = "";

		for ( $i = 0; $i < count ( $tags ); $i++ )
		{
			if ( !ereg ( ":", $tags[$i] ) )
			{
				$result .= trim ( $tags[$i] ).";";
			}
			else
			{
				$parts = explode ( ":", $tags[$i] );

				$result .= trim ( $parts[1] ).";";
			}
		}

		return $result;
	}

	function get_tags_array ()
	{
		$tags = $this->get ( "tags" );

		$tags = explode ( ";", $tags );

		$result = array ();

		for ( $i = 0; $i < count ( $tags ); $i++ )
		{
			if ( !empty ( $tags[$i] ) )
			{
				if ( eregi ( ":", $tags[$i] ) )
				{
					//$parts = explode ( ":", $tags[$i] );

					//$result[] = trim ( $parts[1] );
				}
				else
				{
					$result[] = trim ( $tags[$i] );
				}
			}
		}

		return $result;
	}

	function get_cats_array ()
	{
		$tags = $this->get ( "tags" );

		$tags = explode ( ";", $tags );

		$result = array ();

		for ( $i = 0; $i < count ( $tags ); $i++ )
		{
			if ( !empty ( $tags[$i] ) )
			{
				if ( eregi ( ":", $tags[$i] ) )
				{
					$parts = explode ( ":", $tags[$i] );

					$result[trim ( $parts[0] )][] = trim ( $parts[1] );
				}
			}
		}
		
		return $result;
	}

	function get_num_cats ()
	{
		$subtree = new folder ();

		$subtree->subfolders_path ( $this->get ( "path" ), "", "", 1, 1 );

		$cats = $this->get_cats_array ();

		for ( $subtree->i = 0; $subtree->i < $subtree->num_rows; $subtree->i++ )
		{
			$new_cats = $subtree->get_cats_array ();

			if ( count ( $new_cats ) > 0 )
			{
				foreach ( $new_cats as $key => $value )
				{
					for ( $i = 0; $i < count ( $value ); $i++ )
					{
						if ( !in_array ( $value[$i], $cats[$key] ) ) $cats[$key][] = $value[$i];
					}
				}
			}
		}
		
		return count ( $cats );
	}

	function render_cats ( $template )
	{
		$subtree = new folder ();

		$subtree->subfolders_path ( $this->get ( "path" ), "", "", 1, 1 );

		$cats = $this->get_cats_array ();

		for ( $subtree->i = 0; $subtree->i < $subtree->num_rows; $subtree->i++ )
		{
			$new_cats = $subtree->get_cats_array ();

			if ( count ( $new_cats ) > 0 )
			{
				foreach ( $new_cats as $key => $value )
				{
					for ( $i = 0; $i < count ( $value ); $i++ )
					{
						if ( !in_array ( $value[$i], $cats[$key] ) ) $cats[$key][] = $value[$i];
					}
				}
			}
		}

		ob_start ();

		foreach ( $cats as $key => $value )
		{
			sort ( $value );
		
			$num_values = count ( $value );
		
			include ( $GLOBALS["path_template"].$template );
		}

		$buffer = ob_get_clean ();
		
		echo $buffer;
	}

	function render_tag_cloud ( $template, $num = 0 )
	{
		global $shuffle_cloud;

		$type = "[render_tag_cloud][".$template."][".$num."][".$shuffle_cloud."][".$GLOBALS["root_color"]."][".$GLOBALS["fontsize"]."]";

		$buffer = _get_cached ( $this->get ( "path" ), $type );

		//if ( ( $buffer === false ) || $GLOBALS["no_render_cache"] )
		{
			ob_start ();

			$subtree = new folder ();

			$subtree->subfolders_path ( $this->get ( "path" ), "", "", 1, 1 );

			$tags = $this->get_tags_array ();

			for ( $subtree->i = 0; $subtree->i < $subtree->num_rows; $subtree->i++ )
			{
				$tags = array_merge ( $tags, $subtree->get_tags_array () );
			}

			$num_tags = count ( $tags );

			$new_tags = array ();

			$max_freq = 0;

			for ( $i = 0; $i < $num_tags; $i++ )
			{
				$tag = trim ( stripslashes ( $tags[$i] ) );

				if ( !empty ( $tag ) )
				{
					if ( !isset ( $new_tags[$tag] ) ) $new_tags[$tag] = 0;

					else
					{
						$new_tags[$tag]++;

						if ( $new_tags[$tag] > $max_freq ) $max_freq = $new_tags[$tag];
					}
				}
			}

			asort ( $new_tags );

			$tags = array_reverse ( $new_tags );

			$num_tags = count ( $tags );

			$i = 1;

			$new_tags = array ();

			foreach ( $tags as $key => $value )
			{
				$new_tags[$i]["name"] = $key;
				$new_tags[$i]["freq"] = $value;

				if ( $i++ == ( $num + 1 ) ) break;
			}

			$tags = $new_tags;

			if ( $shuffle_cloud ) sort ( $tags );

			$num_tags = count ( $tags );

			for ( $i = 1; $i <= $num_tags; $i++ )
			{
				include ( $GLOBALS["path_template"].$template );
			}

			$buffer = ob_get_clean ();

			_set_cached ( $this->get ( "path" ), $type, $buffer );
		}

		echo $buffer;
	}

	function render_feed ( $template, $id_feed )
	{
		$rss_links = $this->get ( "feeds" );

		$rss_links = explode ( ";", $rss_links );

		if ( $id_feed < count ( $rss_links ) )
		{
			$rss = new rss ( trim ( $rss_links[$id_feed] ) );

			include ( $GLOBALS["path_template"].$template );
		}
	}

	function render_feeds ( $template )
	{
		$rss_links = $this->get ( "feeds" );

		$rss_links = explode ( ";", $rss_links );

		for ( $i = 0; $i < count ( $rss_links ); $i++ ) include ( $GLOBALS["path_template"].$template );
	}

	function get_num_feeds ()
	{
		$rss_links = $this->get ( "feeds" );

		$rss_links = explode ( ";", $rss_links );

		return count ( $rss_links );
	}

	function render_rss_if ( $template )
	{
		global $rss_file;

		if ( file_exists ( $GLOBALS["home"].$this->get ( "path" )."/".$rss_file ) ) include ( $GLOBALS["path_template"].$template );
	}

	function set_as_wallpaper ( $file )
	{
		return copy ( $GLOBALS["home"].$this->get ( "path" )."/".$file, $GLOBALS["path_images"]."background.jpg" );
	}

	function set_as_cover ( $file )
	{
		$extension = strtolower ( substr ( $file, strrpos ( $file, '.' ) + 1 ) );

		copy ( $GLOBALS["home"].$this->get ( "path" )."/".$file, $GLOBALS["home"].$this->get ( "path" )."/"."cover.".$extension );
	}
}

?>