<?

/*

 	Webmedia Explorer 5.0 - Multimedia Management System
 	Copyright (C) 2007 Marc Salmurri (marc.salmurri@gmail.com)

 	This program is free software; you can redistribute it and/or modify
 	it under the terms of the GNU General Public License as published by
 	the Free Software Foundation; either version 2 of the License, or (at
 	your option) any later version.

 	This program is distributed in the hope that it will be useful, but
 	WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 	General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with this program; if not, write to the Free Software
 	Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.

*/

	ob_start ();

	// ------------------------------------------------------------------

	set_time_limit ( 0 );

	error_reporting ( E_ERROR );

	include ( "conf/config.lib.php" );

	session_start ();	

	include ( $path_include."core.lib.php" );

	// ------------------------------------------------------------------
	
	function render_quotes ( $template )
	{
		global $quote_file;
		
		$quotes = file_get_contents ( $GLOBALS["home"]."/".$quote_file );
	
		$quotes = explode ( "\n", $quotes );

		sort ( $quotes );

		for ( $i = 0; $i < count ( $quotes ); $i++ )
		{
			include ( $GLOBALS["path_template"].$template );
		}
	}
	
	function get_random_quote ()
	{
		global $quote_file;

		$quotes = file_get_contents ( $GLOBALS["home"]."/".$quote_file );
	
		$quotes = explode ( "\n", $quotes );

		return $quotes[rand ( 1, count ( $quotes ) - 1)];	
	}
	
	function render_stack ( $template )
	{
		global $dir_stack;

		$total = count ( $dir_stack );

		$current = new folder ();

		for ( $i = 0; $i < $total; $i++ )
		{
			$current->folder_path ( $dir_stack[$i]["dir"] );

			$current->render ( $template );
		}
	}
	
	function render_languages ( $template )
	{
		global $languages;
		
		$n_languages = count ( $languages );
		
		for ( $i = 0; $i < $n_languages; $i++ )
		{
			include ( $GLOBALS["path_template"].$template );
		}
	}

	function render_backgrounds ( $template )
	{
		global $backgrounds;
		
		$n_backgrounds = count ( $backgrounds );
		
		for ( $i = 0; $i < $n_backgrounds; $i++ )
		{
			include ( $GLOBALS["path_template"].$template );
		}
	}

	function render_colors ( $template )
	{
		global $colors;
		
		for ( $i = 0; $i < count ( $colors ); $i++ )
		{
			include ( $GLOBALS["path_template"].$template );
		}
	}

	function render_color ( $template, $i )
	{
		global $colors;
		
		for ( $j = 0; $j < count ( $colors[$i] ); $j++ )
		{
			include ( $GLOBALS["path_template"].$template );
		}
	}
	
	function render_image ( $image, $max, $dir = "", $template = "", $id = "" )
	{
		if ( empty ( $dir ) ) $dir = $GLOBALS["dir"];

		if ( !empty ( $image ) )
		{
			$buffer = ob_start ();

			if ( empty ( $id ) ) $id = $image;

			$data = _create_thumb ( $image, "th_".$max."_", $max, $dir );

			if ( empty ( $template ) ) { ?><img border="0" height="<?= $data["height"] ?>" src="<?= $data["file"] ?>" id="<?= $id ?>"><? }

			else include ( $GLOBALS["path_template"].$template );
			
			$buffer = ob_get_clean ();
		
			return $buffer;
		}
	}

	function _init ( $name = "" )
	{
		global $time_elapsed, $te;

		if ( !isset ( $te ) )
		{
			$te = 0;

			$time_elapsed = array ();
		}

		if ( empty ( $name ) ) $name = $te;

		$time_elapsed[$name]["time"] = getmicrotime ();
	}

	function _end ( $name = "" )
	{
		global $time_elapsed, $te;

		if ( empty ( $name ) ) $name = $te;

		$time_elapsed[$name]["time"] = getmicrotime () - $time_elapsed[$name]["time"];

		$te++;
	}
	
	function _time_dump ()
	{
		global $time_elapsed;

		foreach ( $time_elapsed as $key => $value )
		{
			$big = "";

			if ( $value["time"] > 100 ) $big = "size='6'";
		
			echo "<font color='black' ".$big.">".$key.": ".number_format ( $value["time"], 0, ",", "." )." ms</font><br>";
		}
	}
	
	// ------------------------------------------------------------------

	_init ( "elapsed" );

	if ( !file_exists ( ".htaccess" ) ) include ( $path_include."htaccess.lib.php" );

	$user = new user ();

	if ( !$user->user_username_password ( $_SESSION["username"], $_SESSION["password"] ) ) $user->user_username_password ( $_COOKIE["username"], base64_decode ( $_COOKIE["password"] ) );

	$colors = new color ();

	$colors->colors ( $color );

	if ( !$colors->is_color ( "#".$_GET["root_color"] ) ) unset ( $_GET["root_color"] );

	set_var ( "root_color" );

	$root_color = "#".$root_color;

	create_artwork ();

	// ------------------------------------------------------------------

	set_var ( "width" ); if ( !in_array ( $GLOBALS["width"], $valid["width"] ) ) $GLOBALS["width"] = $valid["width"][1];

	set_var ( "sidebar" ); if ( !in_array ( $GLOBALS["sidebar"], $valid["sidebar"] ) ) $GLOBALS["sidebar"] = $valid["sidebar"][1];

	// ------------------------------------------------------------------

	set_var ( "mini_icons" );

	set_var ( "num_cols" );

	if ( $GLOBALS["num_cols"] > $GLOBALS["max_cols"][$GLOBALS["width"]] ) $GLOBALS["num_cols"] = $GLOBALS["max_cols"][$GLOBALS["width"]];

	if ( $GLOBALS["num_cols"] > $GLOBALS["max_cols"] ) $GLOBALS["num_cols"] = $GLOBALS["max_cols"];

	// ------------------------------------------------------------------

	set_var ( "fontsize" );			if ( !in_array ( $GLOBALS["fontsize"], $valid["fontsize"] ) ) $GLOBALS["fontsize"] = $valid["fontsize"][1];

	set_var ( "background" );		if ( ( $GLOBALS["background"] < 0 ) || ( $GLOBALS["background"] > count ( $backgrounds ) ) ) $GLOBALS["background"] = 0;

	set_var ( "view" );				if ( $GLOBALS["view"] == 3 ) 		$subdirs_template = "folders_3.tpl.php";

									else if ( $GLOBALS["view"] == 2 ) 	$subdirs_template = "folders_2.tpl.php";

									else 						 		$subdirs_template = "folders_1.tpl.php";

	// ------------------------------------------------------------------	

	$root 				= new folder ();

	$root->folder_path ();

	$folder 			= new folder ();

	$GLOBALS["dir"] = $folder->clean_link ( $_GET["dir"] );

	if ( !$folder->folder_path ( $GLOBALS["dir"] ) ) exit;
	
	if ( ( !$user->is_admin () ) && ( $folder->I_am_post () ) && ( $folder->get ( "filetime" ) > mktime () ) ) exit;

	$folder->validate_user ();

	// ------------------------------------------------------------------

	set_var ( "language" );			if ( !isset ( $languages[$GLOBALS["language"]] ) ) $GLOBALS["language"] = 0;
	
	include ( $path_include."language/".$languages[$GLOBALS["language"]]["file"].".lib.php" );

	// ------------------------------------------------------------------	

	$GLOBALS["image"]		= $_GET["image"];
	
	$GLOBALS["other"]		= $_GET["other"];
	
	$GLOBALS["bookmark"]	= $_GET["bookmark"];

	$GLOBALS["search"] 		= strip_tags ( trim ( $_GET["search"], ";" ) );
	
	if ( strlen ( $GLOBALS["search"] ) < 3 ) unset ( $GLOBALS["search"] );
	
	$GLOBALS["tag"] 		= trim ( $_GET["tag"], ";" );

	$GLOBALS["archive"]		= $_GET["archive"];

	$GLOBALS["id_message"] 	= $_GET["id_message"];
	
	if ( !isset ( $_GET["id_message"] ) ) $GLOBALS["id_message"] = 0;

	$GLOBALS["ini"] 		= $_GET["ini"];

	if ( empty ( $GLOBALS["ini"] ) || ( $GLOBALS["ini"] < 0 ) ) $GLOBALS["ini"] = 0;
	
	$GLOBALS["num"] 		= $_GET["num"];
	
	if ( !empty ( $GLOBALS["num"] ) && !in_array ( $GLOBALS["num"], $GLOBALS["valid"]["num"] ) ) $GLOBALS["num"] = $GLOBALS["valid"]["num"][0];

	// ------------------------------------------------------------------

	$GLOBALS["dir_stack"] 	= unserialize ( stripslashes ( $_COOKIE["dir_stack_cookie"] ) );

	$GLOBALS["n_stack"] 	= 0;

	if ( is_array ( $GLOBALS["dir_stack"] ) ) $GLOBALS["n_stack"] = count ( $GLOBALS["dir_stack"] );

	if ( !isset ( $_GET["image"] ) && !isset ( $_GET["id_message"] ) )
	{	
		if ( $GLOBALS["n_stack"] >= $GLOBALS["dir_stack_num"] ) unset ( $GLOBALS["dir_stack"][$GLOBALS["dir_stack_num"]] );

		if ( ( ( $GLOBALS["dir_stack"][0]["dir"] != $GLOBALS["dir"] ) && ( !empty ( $_GET["dir"] ) ) ) )
		{
			$stack_name = $folder->get ( "name" );
		
			if ( $folder->I_am_post () ) $stack_name = $folder->get ( "desc" );
		
			if ( !empty ( $stack_name ) )
			{
				$stack_item = array ( "dir" => $GLOBALS["dir"], "name" => $stack_name );

				if ( $GLOBALS["n_stack"] > 0 ) array_unshift ( $GLOBALS["dir_stack"], $stack_item );

				else $GLOBALS["dir_stack"] = array ( $stack_item );
			}
		}

		setcookie ( "dir_stack_cookie", serialize ( $GLOBALS["dir_stack"] ), 0, "/", $_SERVER["SERVER_NAME"] );

		$_COOKIE["dir_stack_cookie"] = serialize ( $GLOBALS["dir_stack"] );
	}

	// ------------------------------------------------------------------

	$main_template 		= "main.tpl.php";

	$inner_template 	= "gallery.tpl.php";

	if ( $_GET["action"] == "quotes" )				$inner_template = "quotes.tpl.php";

	else if ( $_GET["action"] == "config" )			$inner_template = "config.tpl.php";

	else if ( $_GET["action"] == "history" )		$inner_template = "history.tpl.php";

	else if ( $_GET["action"] == "archives" )		$inner_template = "archives.tpl.php";

	else if ( $_GET["action"] == "tree" )			$inner_template = "tree.tpl.php";

	else if ( $_GET["action"] == "rss" ) 			$main_template 	= "folder_rss.tpl.php";

	else if ( $_GET["action"] == "messages" )
	{
		$inner_template 				= "messages.tpl.php";

		$folder_message_template 		= "folder_messages.tpl.php";

		$folder_message_nav_template 	= "folder_messages_nav.tpl.php";

		$num = 20;

		if ( $GLOBALS["id_message"] > 0 )
		{
			$folder_message_template 		= "folder_message.tpl.php";
			
			$folder_message_nav_template 	= "empty.tpl.php";
		}

		if ( $_POST["object"] == "message" )
		{
			if ( $_POST["id_message"] > 0 )
			{
				if ( $user->is_admin () ) $folder->update_message ( $_POST );
			}
			else
			{
				$_SESSION["nickname"] 	= $_POST["nickname"];

				$_SESSION["email"] 		= $_POST["email"];

				if ( $folder->create_message ( $_POST ) ) $_POST = array ();
			}

			header ( "location: ".$_SERVER["REQUEST_URI"] ); exit;
		}

		$_SESSION["captcha_code"] = substr ( eregi_replace ( "[a-z]", "", md5 ( mt_rand ( 1, 10000 ) ) ), 2, 6 );
	}

	else if ( $_GET["action"] == "register" )
	{
		if ( count ( $_POST ) > 0 )
		{
			$GLOBALS["register_error"] = $user->register ( $_POST );
		}

		$inner_template = "user_register.tpl.php";
	}

	else if ( $_GET["action"] == "activate" )
	{
		$user->activate ( $_GET );
	}

	else if ( $_GET["action"] == "unregister" )
	{
		if ( count ( $_POST ) > 0 )
		{
			$user->unregister ( $_POST );
		}

		$inner_template = "user_unregister.tpl.php";
	}

	else if ( ( $_GET["action"] == "deactivate" )   )
	{
		$user->deactivate ( $_GET );
	}

	else if ( $_GET["action"] == "remember" )
	{
		if ( count ( $_POST ) > 0 )
		{
			$GLOBALS["remember_error"] = $user->remember ( $_POST );
		}

		$_SESSION["captcha_code"] = substr ( eregi_replace ( "[a-z]", "", md5 ( mt_rand ( 1, 10000 ) ) ), 2, 6 );

		$inner_template = "user_remember.tpl.php";
	}

	else if ( $_GET["action"] == "login" )
	{
		$user->login ( array_merge ( $_POST, $_GET ) );

		$inner_template = "user.tpl.php";
	}

	else if ( $_GET["action"] == "logout" )
	{
		$user->logout ();
	}

	else if ( ( $user->is_admin () ) &&  $_GET["action"] == "set_as_wallpaper" )
	{
		$folder->set_as_wallpaper ( $_GET["image"] );

		$GLOBALS["background"] = 0;

		set_var ( "background" );
	}

	else if ( ( $user->is_admin () ) &&  $_GET["action"] == "set_as_cover" )
	{
		$folder->set_as_cover ( $_GET["image"] );

		header ( "location: ".$GLOBALS["url_base"]."?dir=".$GLOBALS["dir"]."&refresh=1" ); exit;
	}

	else if ( ( $user->is_admin () ) && $_GET["action"] == "edit" )
	{
		if ( isset ( $_GET["other"] )  )
		{
													$inner_template = "folder_edit_other.tpl.php";
		}
		else if ( isset ( $_GET["image"] ) )
		{
													$inner_template = "folder_edit_image.tpl.php";
		}
		else if ( isset ( $_GET["bookmark"] ) )
		{
													$inner_template = "folder_edit_bookmark.tpl.php";
		}
		else if ( isset ( $_GET["id_message"] ) )
		{
													$inner_template = "folder_edit_message.tpl.php";
		}
		else 										$inner_template = "folder_edit.tpl.php";
	}

	else if ( ( $user->is_admin () ) &&  $_GET["action"] == "new" )
	{
		if ( $_GET["object"] == "folder" ) 			$inner_template = "folder_new.tpl.php";
		
		else if ( $_GET["object"] == "post" ) 		$inner_template = "post_new.tpl.php";
		
		else if ( $_GET["object"] == "file" ) 		$inner_template = "file_new.tpl.php";
		
		else if ( $_GET["object"] == "bookmark" )	$inner_template = "bookmark_new.tpl.php";
		
		else if ( $_GET["object"] == "rss" ) 		$inner_template = "rss_new.tpl.php";
	}
	else if ( ( $user->is_admin () ) && $_GET["action"] == "protect" )
	{
		if ( $_GET["object"] == "folder" )
		{
			$inner_template = "folder_protect.tpl.php";
		}
	}
	else if ( ( $user->is_admin () ) && $_GET["action"] == "unprotect" )
	{
		if ( $_GET["object"] == "folder" )
		{
			$folder->unprotect ();
		}
	}

	else if ( ( $user->is_admin () ) && $_GET["action"] == "copy" )
	{
		$_SESSION["dir"] 			= $GLOBALS["dir"];
		
		unset ( $_SESSION["other"] );

		unset ( $_SESSION["image"] );

		unset ( $_SESSION["bookmark"] );

		if ( $_GET["object"] == "other" )
		{
			$_SESSION["dir"] 		= $GLOBALS["dir"];

			$_SESSION["other"] 		= $GLOBALS["other"];

			unset ( $_SESSION["image"] );
			unset ( $_SESSION["bookmark"] );
		}
		else if ( $_GET["object"] == "image" )
		{
			$_SESSION["dir"] 		= $GLOBALS["dir"];

			$_SESSION["image"] 		= $GLOBALS["image"];

			unset ( $_SESSION["other"] );
			unset ( $_SESSION["bookmark"] );
		}
		else if ( $_GET["object"] == "bookmark" )
		{
			$_SESSION["dir"] 		= $GLOBALS["dir"];

			$_SESSION["bookmark"] 	= $GLOBALS["bookmark"];

			unset ( $_SESSION["other"] );
			unset ( $_SESSION["image"] );
		}
	}
	else if ( ( $user->is_admin () ) &&  $_GET["action"] == "paste" )
	{
		if ( $_GET["object"] == "folder" )
		{
			if ( $_SESSION["dir"] != $folder->get ( "path" ) )
			{
				if ( $folder->copy ( $_SESSION["dir"] ) ) unset ( $_SESSION["dir"] );
			
				header ( "location: ".$folder->get_permalink () ); exit;
			}
		}
		else if ( $_GET["object"] == "other" )
		{
			if ( $_SESSION["dir"] != $folder->get ( "path" ) )
			{
				if ( $folder->copy_other ( $_SESSION["dir"], $_SESSION["other"] ) )
				{
					unset ( $_SESSION["dir"] );
					unset ( $_SESSION["other"] );
				}

				header ( "location: ".$folder->get_permalink () ); exit;
			}
		}
		else if ( $_GET["object"] == "image" )
		{
			if ( $_SESSION["dir"] != $folder->get ( "path" ) )
			{
				if ( $folder->copy_other ( $_SESSION["dir"], $_SESSION["image"] ) )
				{
					unset ( $_SESSION["dir"] );
					unset ( $_SESSION["image"] );
				}

				header ( "location: ".$folder->get_permalink () ); exit;
			}
		}
		else if ( $_GET["object"] == "bookmark" )
		{
			if ( $_SESSION["dir"] != $folder->get ( "path" ) )
			{
				if ( $folder->copy_bookmark ( $_SESSION["dir"], $_SESSION["bookmark"] ) )
				{
					unset ( $_SESSION["dir"] );
					unset ( $_SESSION["bookmark"] );
				}

				header ( "location: ".$folder->get_permalink () ); exit;
			}
		}
	}
	else
	{
		if ( ( $user->is_admin () ) && $_GET["action"] == "delete" )
		{
			if ( isset ( $_GET["other"] ) )
			{
				$folder->delete_other ( $_GET["other"] );
			}
			else if ( isset ( $_GET["image"] ) )
			{
				$folder->delete_image ( $_GET["image"] );
				
				unset ( $GLOBALS["image"] );
			}
			else if ( isset ( $_GET["bookmark"] ) )
			{
				$folder->delete_bookmark ( $_GET["bookmark"] );
			}
			else if ( isset ( $_GET["id_message"] ) )
			{
				$id_ancestor = $folder->delete_message ( $_GET["id_message"] );

				if ( ( $id_ancestor > 0 ) && ( $id_ancestor != $_GET["id_message"] ) )
				{
					$message = new message ();

					$message->message_path_message ( $folder->get ( "path" ), $id_ancestor );

					header ( "location: ".$message->get_permalink () ); exit;
				}

				header ( "location: ".$folder->get_permalink ()."&action=messages" ); exit;
			}
			else
			{
				$folder->delete ();
			}

			header ( "location: ".$folder->get_permalink () ); exit;
		}
		else if ( ( $user->is_admin () ) && $_GET["action"] == "empty" )
		{
			$folder->clear ();

			header ( "location: ".$folder->get_link () ); exit;
		}
		else if ( ( $user->is_admin () ) && ( count ( $_POST ) > 0 ) )
		{
			switch ( $_POST["object"] )
			{
				case "folder":
				{
					if ( strlen ( $_POST["username"] ) > 0 ) $folder->protect ( $_POST["username"], $_POST["password"] );

					else $folder->update ( $_POST );

					break;
				}

				case "subfolder": { $folder->create_subfolder ( $_POST ); break; }

				case "file": { $folder->upload_file ( $_FILES ); break; }

				case "other": { $folder->update_other ( $_POST ); break; }

				case "image": { $folder->update_image ( $_POST ); break; }

				case "post": { $folder->create_post ( $_POST ); break; }

				case "bookmark": { $folder->create_update_bookmark ( $_POST ); break; }

				case "rss": { $folder->create_rss ( $_POST ); break; }
			}

			if ( $_POST["object"] ) header ( "location: ".$folder->get_permalink () ); exit;
		}

		// ------------------------------------------------------------------

		if ( !empty ( $GLOBALS["image"] ) )										$inner_template = "image.tpl.php";

		else if ( !empty ( $GLOBALS["search"] ) || !empty ( $GLOBALS["tag"] ) )	$inner_template = "search_tree.tpl.php";
	}

	// ------------------------------------------------------------------

	include ( $path_template.$main_template );

	$buffer = ob_get_clean ();

	echo $buffer;
	
?>